package eyrolles;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public class LookupAction extends Action {

  protected Double getCotation(String symbole) {

    if ( symbole.equalsIgnoreCase("SUNW") ) {

      return new Double(25.00);
    }
    return null;
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {
        
    EyrollesActionMapping eyrollesMapping = (EyrollesActionMapping) mapping;

    Double cours = null;

    // Cible par dfaut
    String cible = new String("succes");
    String symbole = null;

    if ( form != null ) {

      // Utilisation de LookupForm pour obtenir les paramtres de la requte
      LookupForm lookupForm = (LookupForm)form;

      symbole = lookupForm.getSymbole();

      cours = getCotation(symbole);
    }

    // Cible en cas d'chec
    if ( cours == null ) {

      cible = new String("echec");
      ActionErrors erreurs = new ActionErrors();
      erreurs.add(ActionErrors.GLOBAL_ERROR,
        new ActionError("erreurs.recherche.symbole.inconnu", symbole));

      // Signalement des erreurs  la page d'origine
      if (!erreurs.empty()) {

        saveErrors(request, erreurs);
      }

    }
    else {
      if (eyrollesMapping.getLogResultats()) {
        System.err.println("SYMBOLE:" + symbole + "  COURS:" + cours);
      }
      request.setAttribute("COURS", cours);
    }
    // Transmission  la vue approprie
    return (mapping.findForward(cible));
  }
}
