package eyrolles;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

import javax.servlet.ServletContext;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class LookupAction extends Action {

  protected Double getCotation(String symbole) {

    Double cours = null;
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;

    ServletContext context = servlet.getServletContext();
    DataSource dataSource = (DataSource)
      context.getAttribute(Action.DATA_SOURCE_KEY);

    try {

      conn = dataSource.getConnection();
      stmt = conn.createStatement();
      rs = stmt.executeQuery("select * from cotations where "
        + "symbole='" + symbole + "'");

      if ( rs.next() ) {

        double tmp = 0;
        tmp = rs.getDouble("cours");

        cours = new Double(tmp);

        System.err.println("cours : "
          + cours);
      }
      else {

        System.err.println("---->Symbole non trouv<----");
      }
    }
    catch (SQLException e) {

      System.err.println(e.getMessage());
    }
    finally {

      if (rs != null) {

        try {

          rs.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        rs = null;
      }
      if (stmt != null) {

        try {

          stmt.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        stmt = null;
      }
      if (conn != null) {

        try {

          conn.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        conn = null;
      }
    }
    return cours;
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {
        
    EyrollesActionMapping eyrollesMapping = (EyrollesActionMapping) mapping;

    Double cours = null;

    // Cible par dfaut
    String cible = new String("succes");
    String symbole = null;

    if ( form != null ) {

      // Utilisation de LookupForm pour obtenir les paramtres de la requte
      LookupForm lookupForm = (LookupForm)form;

      symbole = lookupForm.getSymbole();

      cours = getCotation(symbole);
    }

    // Cible en cas d'chec
    if ( cours == null ) {

      cible = new String("echec");
      ActionErrors erreurs = new ActionErrors();
      erreurs.add(ActionErrors.GLOBAL_ERROR,
        new ActionError("erreurs.recherche.symbole.inconnu", symbole));

      // Signalement des erreurs  la page d'origine
      if (!erreurs.empty()) {

        saveErrors(request, erreurs);
      }

    }
    else {
      if (eyrollesMapping.getLogResultats()) {
        System.err.println("SYMBOLE:" + symbole + "  COURS:" + cours);
      }
      request.setAttribute("COURS", cours);
    }
    // Transmission  la vue approprie
    return (mapping.findForward(cible));
  }
}
