package com.eyrolles;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

public class EmployeForm extends ActionForm {

  protected String username;
  protected String password;
  protected String name;
  protected String phone;
  protected String email;
  protected String depid;
  protected String roleid;

  public void setUsername(String username) {

    this.username = username;
  }

  public String getUsername() {

    return username;
  }

  public void setPassword(String password) {

    this.password = password;
  }

  public String getPassword() {

    return password;
  }

  public void setName(String name) {

    this.name = name;
  }

  public String getName() {

    return name;
  }

  public void setPhone(String phone) {

    this.phone = phone;
  }

  public String getPhone() {

    return phone;
  }

  public void setEmail(String email) {

    this.email = email;
  }

  public String getEmail() {

    return email;
  }

  public void setDepid(String depid) {

    this.depid = depid;
  }

  public String getDepid() {

    return depid;
  }

  public void setRoleid(String roleid) {

    this.roleid = roleid;
  }

  public String getRoleid() {

    return roleid;
  }

  // Cette mthode est appele par chaque requte. Elle rinitialise les
  // attributs du formulaire avant de copier les donnes de la nouvelle requte.
  public void reset(ActionMapping mapping, HttpServletRequest request) {

    this.username = "";
    this.password = "";
    this.name = "";
    this.phone = "";
    this.email = "";
    this.depid = "1";
    this.roleid = "1";
  }

  public ActionErrors validate(ActionMapping mapping,
    HttpServletRequest request) {

    ActionErrors errors = new ActionErrors();

    EmployesActionMapping employesMapping =
      (EmployesActionMapping)mapping;

    // Cette action ncessite-t-elle l'identification de l'utilisateur ?
    if ( employesMapping.isLoginRequired() ) {

      HttpSession session = request.getSession();
      if ( session.getAttribute("USER") == null ) {

        // retourner null force l'action  traiter l'erreur de login
        return null;
      }
    }

    if ( (roleid == null ) || (roleid.length() == 0) ) {

      errors.add("roleid", new ActionError("errors.roleid.required"));
    }
    if ( (depid == null ) || (depid.length() == 0) ) {

      errors.add("depid", new ActionError("errors.depid.required"));
    }
    if ( (email == null ) || (email.length() == 0) ) {

      errors.add("email", new ActionError("errors.email.required"));
    }
    if ( (phone == null ) || (phone.length() == 0) ) {

      errors.add("phone", new ActionError("errors.phone.required"));
    }
    if ( (name == null ) || (name.length() == 0) ) {

      errors.add("name", new ActionError("errors.name.required"));
    }
    if ( (password == null ) || (password.length() == 0) ) {

      errors.add("password", new ActionError("errors.password.required"));
    }
    if ( (username == null ) || (username.length() == 0) ) {

      errors.add("username", new ActionError("errors.username.required"));
    }
    return errors;
  }
}
