package com.eyrolles;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.ArrayList;

public class EmployeListeAction extends Action {

  protected ArrayList getEmployes() {

    Employe employe = null;
    ArrayList employes = new ArrayList();
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;

    ServletContext context = servlet.getServletContext();
    DataSource dataSource = (DataSource)
      context.getAttribute(Action.DATA_SOURCE_KEY);

    try {

      conn = dataSource.getConnection();
      stmt = conn.createStatement();
      rs =
        stmt.executeQuery("select * from employes, roles, "
        + "services where employes.roleid=roles.roleid "
        + "and employes.depid=services.depid");

      while ( rs.next() ) {

        employe = new Employe();

        employe.setUsername(rs.getString("username"));
        employe.setName(rs.getString("name"));
        employe.setRolename(rs.getString("rolename"));
        employe.setPhone(rs.getString("phone"));
        employe.setEmail(rs.getString("email"));
        employe.setRoleid(new Integer(rs.getInt("roleid")));
        employe.setDepid(new Integer(rs.getInt("depid")));
        employe.setDepartment(rs.getString("depname"));

        employes.add(employe);

        System.err.println("Username : "
          + employe.getUsername()
          + " Department : " + rs.getString("depname"));
      }
    }
    catch (SQLException e) {

      System.err.println(e.getMessage());
    }
    finally {

      if (rs != null) {

        try {

          rs.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        rs = null;
      }
      if (stmt != null) {

        try {

          stmt.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        stmt = null;
      }
      if (conn != null) {

        try {

          conn.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        conn = null;
      }
    }
    return employes;
  }

  public ActionForward execute(ActionMapping mapping,
    ActionForm form,
    HttpServletRequest request,
    HttpServletResponse response)
    throws IOException, ServletException {

    // Default target to success
    String target = new String("success");

    EmployesActionMapping employesMapping =
      (EmployesActionMapping)mapping;

    // Does this action require the user to login
    if ( employesMapping.isLoginRequired() ) {

      HttpSession session = request.getSession();
      if ( session.getAttribute("USER") == null ) {

        // The user is not logged in
        target = new String("login");
        ActionErrors errors = new ActionErrors();

        errors.add(ActionErrors.GLOBAL_ERROR,
          new ActionError("errors.login.required"));

        // Report any errors we have discovered back to
        // the original form
        if (!errors.empty()) {

          saveErrors(request, errors);
        }
      }
    }

    ArrayList employes = null;

    employes = getEmployes();

    // Set the target to failure
    if ( employes == null ) {

      target = new String("login");
    }
    else {

      request.setAttribute("employes", employes);
    }
    // Forward to the appropriate View
    return (mapping.findForward(target));
  }
}