package chapitre2;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

public class ContextServlet extends HttpServlet {

    private static final String CONTENT_TYPE = "text/html";

    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        doPost(request, response);
    }

    public void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        // Obtention d'une rfrence au ServletContext
        ServletContext context = getServletContext();

        // Lecture du nom d'utilisateur dans le ServletContext
        String userName = (String) context.getAttribute("USERNAME");

        // Si l'attribut est absent, cration d'un nouvel attribut
        // dans le ServletContext
        if (userName == null) {
            userName = new String("Bob Roberts");
            context.setAttribute("USERNAME", userName);
        }

        response.setContentType(CONTENT_TYPE);
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head><title>Servlet Context</title></head>");
        out.println("<body>");

        // Affichage de la valeur de l'attribut USERNAME
        out.println("<p>Le nom de l'utilisateur est : " + userName
                + ".</p>");

        out.println("</body></html>");
        out.close();
    }
}
